// Generator sygnalu PWM (wyjscie - linia C8).
// Wspolczynniki wypelnienia przenoszone sa kanalem DMA
// co 3 sekundy (przepelnienie TIM4).

#include <stdio.h>
#include "stm32f4xx.h"

// Tablica wspolczynnikow wypelnienia.

uint16_t duty_tab[4]={99, 499, 749, 899};

int main (void) {

// Konfiguracja niezbednych peryferiow:
	
  RCC->AHB1ENR |= (1<<21)|(1<<2);				// Wlacz "zegar" GPIOC  i DMA1.
	RCC->APB1ENR |= (1<<1) | (1<<2); 			// Wlacz "zegar" TIM4 i TIM3.

// --- 1 ---
// Ustaw tryb pracy linii C8 - wyjscie kanalu 3 timera TIM3.	

//  GPIOC->MODER =
//	GPIOC->AFR[1] = 
//	GPIOC->OSPEEDR =

// Konfiguracja Timera 3 - generator PWM
	
	TIM3->PSC = 15999;										// Preskaler.
	TIM3->ARR = 999;											// Zakres zliczania [0,ARR]
	TIM3->CCMR2 |= (6<<4)|(1<<3);					// Capture/Compare Mode: PWM mode 1, Preload Enable.
	TIM3->CCER |= (0<<9)|(1<<8);					// Wlacz wyjscie kanalu 3, ustaw jego polaryzacje (aktywny stan niski/wysoki).
	TIM3->EGR |=1;												// Przeladuj rejestry licznika podczas jego przepelnienia.
	TIM3->CR1 |=(1<<7)|1;									// Wlacz licznik.

// Konfiguracja Timera 4 - transfery DMA ze stala czestotliwoscia
	
	TIM4->PSC= 15999;											// Preskaler.
	TIM4->ARR= 2999;											// Zakres zliczania	.
	TIM4->DIER |=1<<8;										// Przepelnienie - DMA request.
	TIM4->CR1 |=1;												// Wlacz licznik.

// Konfiguracja DMA

	DMA1_Stream6->PAR = (uint32_t)&(TIM3->CCR3);
	DMA1_Stream6->M0AR = (uint32_t)duty_tab;
	
	DMA1_Stream6->NDTR = 4;								// Liczba przeylanych elementow.
// Memory -> Periph., Circular mode, 16-bit, Memory addr. increment, Ch. 2.
	DMA1_Stream6->CR = (2<<25)|(1<<16)|(1<<13)|(1<<11)|(1<<10)|(1<<8)|(1<<6);
	DMA1_Stream6->CR|=1;									// Wlacz strumien.

	while(1);
	
}
